#version 330 core

layout(location = 0) in vec3 position;     //attribute passsed by the application
layout(location = 1) in vec3 normal;
layout(location = 2) in vec3 color;
layout(location = 3) in vec2 uv;

uniform mat4 modelMatrix;		 //model matrix
//uniform mat4 VP;				 // = P_cam * V_cam 
uniform vec3 cameraPosition;
uniform vec3 LightPos;

out vec3 g_worldNormal;
out vec3 g_materialColor;
out vec2 g_tex_uv;
out vec3 g_directionToLight;
out vec3 g_directionToCamera;

void main()
{
	g_directionToLight = vec3(LightPos.x - position.x, LightPos.y - position.y, LightPos.z - position.z);
	g_directionToLight = normalize(g_directionToLight);
	g_directionToCamera = vec3(cameraPosition.x - position.x, cameraPosition.y - position.y, cameraPosition.z - position.z);
	g_directionToCamera = normalize(g_directionToCamera);

	//standard trandformation
	gl_Position = modelMatrix * vec4(position, 1.0);  //VP * modelMatrix *... Output position of the vertex, in clip space
	g_worldNormal = normalize((modelMatrix * vec4(normal, 0.0)).xyz); 
	g_materialColor = color; 
	g_tex_uv = uv;
}

