#version 330 core

layout(triangles) in;

//3 vertices per tri, output 6 tris (1 for each cm-face)
layout(triangle_strip, max_vertices=18) out;

in vec3 g_worldNormal[];
in vec3 g_materialColor[];
in vec2 g_tex_uv[];
in vec3 g_directionToLight[];
in vec3 g_directionToCamera[];
in vec4 g_Shadow_tex_coord[];

// contains P*V[i], transforms from WS to cubemap-face i
uniform mat4 cm_view_matrices[6];

out vec4 WS_pos_from_GS;
out vec3 f_worldNormal;
out vec3 f_materialColor;
out vec2 f_tex_uv;
out vec3 f_directionToLight;
out vec3 f_directionToCamera;
out vec4 f_Shadow_tex_coord;

void main(void) {
	//iterate over the 6 cubemap faces
	for(gl_Layer=0; gl_Layer<6; gl_Layer++) {
		for(int tri_vert=0; tri_vert<3; tri_vert++) {
			WS_pos_from_GS		= gl_in[tri_vert].gl_Position;
			gl_Position			= cm_view_matrices[gl_Layer] * WS_pos_from_GS;

			f_worldNormal		= g_worldNormal[tri_vert];
			f_materialColor		= g_materialColor[tri_vert];
			f_tex_uv			= g_tex_uv[tri_vert];
			f_directionToLight  = g_directionToLight[tri_vert];
			f_directionToCamera = g_directionToCamera[tri_vert];
			f_Shadow_tex_coord  = g_Shadow_tex_coord[tri_vert];

			EmitVertex();
		}
	EndPrimitive();
	}
}
