#version 330

in vec3 worldNormal;
in vec3 materialColor;
in vec3 N;
in vec3 L;

out vec4 fragColor;

void main()
{
	vec3 ambientColor;
	vec3 diffuseColor;
	vec3 specularColor;
	float ambientIntensity;
	float diffuseIntensity;

	vec3 n = normalize(N);
	vec3 l = normalize(L);

	float diffuseLambertTerm = dot(l,n);

	//without specular
	vec3 color = materialColor;
	ambientColor = color;
	diffuseColor = vec3(1.0f, 1.0f, 0.7f);
	ambientIntensity = 0.8f;
	diffuseIntensity = 0.25f;

	fragColor = vec4((ambientColor*ambientIntensity) + (diffuseColor*diffuseLambertTerm*diffuseIntensity), 1.0f);
}